#!/bin/bash

# ***********************************************************************
# ** Read configs from file
# ***********************************************************************

# CLIENT_RUN_MANUAL=1

WECK_CLIENT_PATH=""

if [ -e "/etc/scripts/distro_plugins" ] || [ -e "/bin/distro_plugins" ] || [ -e "/sbin/init2" ]; then
  WECK_CLIENT_PATH="/home/weckOFFICE"
else
  FILE_NAME="$(readlink -f ${BASH_SOURCE[0]})"
  DIR_NAME=`dirname $FILE_NAME`
  WECK_CLIENT_PATH="$DIR_NAME/.."
fi

. "$WECK_CLIENT_PATH/bin/client_config.sh"

export WECK_CLIENT_PATH
export WECK_RSYNC_SERVER
export WECK_RSYNC_PORT
export RSYNC_PASSWORD
export WECKOFFICE_SERVER
export WECKOFFICE_SERVER_PORT

# ***********************************************************************
# ** Maintain software updated
# ***********************************************************************

echo "" > "$WECK_CLIENT_PATH/log.txt"

"$WECK_CLIENT_PATH/bin/sync" --url http://$WECK_RSYNC_SERVER:$WECK_RSYNC_PORT/FileSync --channel perl-libs --destination "$WECK_CLIENT_PATH/lib" 2>> "$WECK_CLIENT_PATH/log.txt"

# ***********************************************************************
# ** Run weckOFFICE Client
# ***********************************************************************

"$WECK_CLIENT_PATH/bin/client" --send-logs 2>> "$WECK_CLIENT_PATH/log.txt"

if [ -d "$WECK_CLIENT_PATH/tmp" ]; then
  rm -rf $WECK_CLIENT_PATH/tmp/*
fi

