#!/bin/bash

ACTION=$1

# #################################################################
# FUNCTIONS
# #################################################################

function add_to_distro_plugins()
{
  cp -f /etc/scripts/distro_plugins /etc/scripts/distro_plugins.old
  echo "
# weckOFFICE
/home/weckOFFICE/bin/winrest_publish_data.sh PUBLISH_DATA
" >> /etc/scripts/distro_plugins
  sync
  reboot -f
}

function add_to_init2()
{
  cp -f /sbin/init2 /sbin/init2.old
  sed -i 's/# load configuration/\/home\/weckOFFICE\/bin\/winrest_publish_data.sh PUBLISH_DATA\n    # load configuration/' /sbin/init2
  sync
  reboot -f
}

function publish_files()
{
  if [ ! -d "/home/weckOFFICE/to_winrest" ]; then
    mkdir -p /home/weckOFFICE/to_winrest
  fi

  WECKOFFICE_FILES=`ls /home/weckOFFICE/to_winrest`

  if [ "$WECKOFFICE_FILES" != "" ]; then
    mv -f /home/weckOFFICE/to_winrest/* /home/winrest/files/data
    sync

    touch /tmp/stoprest
    cd /home/winrest
    ./winrest > /dev/null &
    sleep 5
    killall winrest
    rm -rf /tmp/stoprest
  fi

  exit
}

# #################################################################
# MAIN CODE
# #################################################################

# Publish files into WinREST
if [ ! -z "$ACTION" ] && [ "$ACTION" == "PUBLISH_DATA" ]; then
  publish_files
# WinREST Distro 500
elif [ -e "/etc/scripts/distro_plugins" ]; then
  HAS_IT=`grep weckOFFICE /etc/scripts/distro_plugins`
  
  if [ "$HAS_IT" == "" ]; then
    add_to_distro_plugins
  fi
# WinREST Distro 412
elif [ -e "/sbin/init2" ]; then
  HAS_IT=`grep PUBLISH_DATA /sbin/init2 | grep weckOFFICE`

  if [ "$HAS_IT" == "" ]; then
    add_to_init2
  fi
fi

