package WO::Class;

use strict;
use warnings;

use Data::Dumper;
use XML::SAX::Simple qw( XMLin );
#use XML::Simple qw( XMLin );

sub new {
  my $c = shift;
  my %a = ( info => {}, @_ );

  my $s = bless {%a}, ref($c) || $c;

  $s->debug("new()");

  $s->init(%a);

  return $s;
}

sub init {}

sub dir  { shift()->{dir} }
sub info { shift()->{info} }

sub config_file { shift()->dir()."/etc/config.xml" }

sub config {
  my $s = shift;

  $s->debug("config()");

  my $h = {};

  if (exists $ENV{CONFIG} && $ENV{CONFIG}) {
    $h = XMLin(
      $ENV{CONFIG},
      KeyAttr => ['id'],
      ForceArray => [ qw(item frontoffice client) ],
    );
  }
  else {
    $h = XMLin(
      $s->config_file(),
      KeyAttr => ['id'],
      ForceArray => [ qw(item frontoffice client) ],
    );
  }

  return $h;
}

sub config_txt {
  my $s = shift;

  $s->debug("config_txt()");

  open(F, "< ".$s->config_file()) || die "Can't open file '".$s->config_file()."': $!";
  local $/ = undef;
  my $config = <F>;
  close(F);

  return $config;
}

sub dump {
  my $s = shift;
  my $r = shift;

  print STDERR Dumper($r);
}

sub debug {
  my $s = shift;
  my $m = shift || "";

  print STDERR "[".ref($s)."] $m\n";
}

1;
