package WO::Client::Integrators::Customers::AE;
# Comograma

use strict;
use warnings;

use base qw ( WO::Client::Common );

use POSIX qw( strftime ceil );
use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
use File::Copy qw( copy move );
use File::Find qw( find );
use File::Spec;
use DBI;
use Text::CSV_XS;
use FindBin qw( $Bin );
use Digest::MD5 qw( md5_hex );
use File::Path qw( mkpath );
use Data::Dumper;

sub sync_fo_information {
  my $s = shift;

  $s->debug("sync_fo_information()");

  my $xml = $s->info();

  my $fo_type = $s->encode_fo_type();

  $s->debug("Encoded FO type is: $fo_type");

  # directory separator
  my $dsep = $s->directory_separator();

  my $tmp_dir = $s->tmp_dir();

  my @readings = ();
  my @to_delete = ();

  &find( sub {
    if (/all_barcode_\d+/) {
      open(F, "< $File::Find::name") or die "Can't open $File::Find::name: $!";
      while (<F>) {
        chop;
        my @toks = split /\s\-\s/;

        #08/30/2010 15:55:35 - 84164452

        my( $month, $day, $year, $hour, $minute, $second ) = $toks[0] =~ /^(\d+)\/(\d+)\/(\d+)\s(\d+)\:(\d+)\:(\d+)$/;

        push @readings, {
          barcode => $toks[1],
          date => "$year-$month-$day",
          hour => "$hour:$minute:$second",
        };
      }
      close(F);

      push @to_delete, $File::Find::name;
    }
  }, ( '/tmp/bcr' ) );

  if (scalar @readings) {
    eval {
      $s->weckoffice_send_data({
        action => 'NetBO_IntegratorsAE_SetManualSales',
        readings => Dumper(\@readings),
      });
    };

    if ($@) {
      die("Error sending file: $@");
    } else {
      for (@to_delete) {
        unlink $_;
        $s->debug("rm -> $_");
      }
    }
  }
  
  return 1;
}

sub sync_bk_information {
  my $s = shift;
  $s->debug("sync_bk_information()");
}

1;

