package WO::Client::Integrators::Customers::Custom1;

use strict;
use warnings;

use base qw ( WO::Client::Common );

use POSIX qw( strftime ceil );
use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
use File::Copy qw( copy move );
use File::Find qw( find );
use File::Spec;
use DBI;
use Text::CSV_XS;
use FindBin qw( $Bin );
use Digest::MD5 qw( md5_hex );
use Data::Dumper;

sub sync_fo_information {
  my $s = shift;
}

sub sync_bk_information {
  my $s = shift;

  $s->debug("sync_bk_information()");

  my $xml = $s->info();

  my $fo_type = $s->encode_fo_type();

  $s->debug("Encoded FO type is: $fo_type");

  my $csv = Text::CSV_XS->new({ binary => 1, sep_char => '#', quote_char => '' });

  # directory separator
  my $dsep = $s->directory_separator();

  my $tmp_dir = $s->tmp_dir();

  my $dir = $s->vfh($xml, 'dir');

  if (! defined $dir) {
    $s->abort("Missing the 'dir' parameter...");
  }

  my $str;
  my $VAR1;

  $s->debug("Will call GetSales_Custom1");

  eval {
    $str = $s->weckoffice_send_data( { action => 'GetSales_Custom1' } );
  };

  if ($@) {
    die("Error: $@");
  }

  eval $str;

  if (defined $VAR1 && ref($VAR1) eq 'ARRAY') {
    my $sales_c = $dir.$dsep."sales_c.csv";
    my $sales_d = $dir.$dsep."sales_d.csv";

    #$s->dump($VAR1);

    open(F, "> $sales_c") or $s->abort("Can't write to $sales_c: $!");
    open(N, "> $sales_d") or $s->abort("Can't write to $sales_d: $!");

    my %done_docs = ();

=pod
          {
            'total_wo_tax' => '0.00000000000000000000',
            'total_w_tax' => '0.0000000',
            'tax_value' => '0.00',
            'store' => 'L9',
            'fo_doc_number' => '62673',
            'date' => '2009-03-21',
            'id' => '2016438',
            'doc_value' => '18.30'
          },
=cut

    my $status = $csv->combine(qw/Q id date fo_doc_number store doc_value/);
    print F $csv->string()."\n";

    $status = $csv->combine(qw/Q id vat_rate total_wo_vat total_w_vat/);
    print N $csv->string()."\n";

    foreach my $r (@$VAR1) {
      my $k = $r->{id};

      if (! exists $done_docs{ $k }) {
        my @v = ();
        
        push @v, "C";
        push @v, $r->{id};
        push @v, $r->{date};
        push @v, $r->{fo_doc_number};
        push @v, $r->{store};
        push @v, sprintf("%0.3f", $r->{doc_value});

        my $status = $csv->combine(@v);
        print F $csv->string()."\n";

        $done_docs{ $k } = 1;
      }

      if ($r->{total_w_tax} > 0) {
        my @v = ();

        push @v, "D";
        push @v, $r->{id};
        push @v, $r->{tax_value}*1;
        push @v, sprintf("%0.3f", $r->{total_wo_tax});
        push @v, sprintf("%0.3f", $r->{total_w_tax});

        my $status = $csv->combine(@v);
        print N $csv->string()."\n";
      }
    }

    close(F);
    close(N);

    my $sales_c = $dir.$dsep."sales_c.csv";
    my $sales_d = $dir.$dsep."sales_d.csv";

    my $sales = $dir.$dsep."sales.csv";

    open(F, "> $sales") or $s->abort("Can't write to $sales: $!");

    #print F "C\n";

    open(N, "< $sales_c");
    while(<N>) {
      print F $_;
    }
    close(N);

    #print F "D\n";

    open(N, "< $sales_d");
    while(<N>) {
      print F $_;
    }
    close(N);

    close(F);

    $s->own_remove($sales_c);
    $s->own_remove($sales_d);
  }

  $VAR1 = undef;

  $s->debug("Will call GetDocuments_Custom1");

  eval {
    $str = $s->weckoffice_send_data( { action => 'GetDocuments_Custom1' } );
  };

  if ($@) {
    die("Error: $@");
  }

  eval $str;

  if (defined $VAR1 && ref($VAR1) eq 'HASH') {
    my $receptions_c = $dir.$dsep."receptions.csv";

    open(F, "> $receptions_c") or $s->abort("Can't write to $receptions_c: $!");

    my %done_docs = ();

=pod
HEADERS:
          {
            'total_payed' => '0.00',
            'date' => '2009-03-18',
            'total_to_pay' => '23.1375',
            'supplier_docref' => '0672/07/001899',
            'date_of_payment' => '2009-03-18',
            'store_code' => 'L1',
            'doc_type_name' => 'Guia Remessa F',
            'discount' => '0.000000',
            'total_iva' => '1.2946',
            'supplier_name' => 'Compras na Loja',
            'supplier_code' => '106',
            'total_p_iva' => '21=0.0000|0=0.0000|30=0.0000|19=0.0000|12=0.3471|5=0.9475|20=0.0000',
            'doc_type' => '301',
            'internal_doc_code' => '18300'
          }

DETAILS:
          {
            'f_qtty' => '500',
            'xtra_cost' => '0.0000',
            'quantity' => '1',
            'family_code' => 'W0000000100',
            'tax' => '20',
            'discount' => '0',
            'internal_doc_code' => '18253',
            'article_name' => 'Saco Transparente 30x40 (Rolo)',
            'buy_price' => '2.9300',
            'article_code' => 'M636',
            'unit_name' => 'RL 500UN'
            'barcode2' => ''
          }
=cut

    #print F "C\n";

    my $status = $csv->combine(qw/Q id date date_of_payment store supplier_code supplier_name supplier_docref doc_type doc_type_name total_to_pay discount payed/);
    print F $csv->string()."\n";

    foreach my $r (@{$VAR1->{headers}}) {
      my @v = ();

      my $payed = $r->{total_to_pay} ne $r->{total_payed} ? 0 : 1;

      push @v, "C";
      push @v, $r->{internal_doc_code};
      push @v, $r->{date};
      push @v, $r->{date_of_payment};
      push @v, $r->{store_code};
      push @v, $r->{supplier_code};
      push @v, $r->{supplier_name};
      push @v, $r->{supplier_docref};
      push @v, $r->{doc_type};
      push @v, $r->{doc_type_name};
      push @v, sprintf("%0.3f", $r->{total_to_pay});
      push @v, sprintf("%0.3f", $r->{discount});
      push @v, $payed;

      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    #print F "D\n";

    $status = $csv->combine(qw/Q id family_code article_code article_name article_barcode2 buy_price discount xtra_cost quantity unit_name f_qtty vat_rate total_wo_vat total_w_vat /);
    print F $csv->string()."\n";

    my %footers;

    foreach my $r (@{$VAR1->{details}}) {
      my @v = ();

      my $row_total = $r->{quantity} * ($r->{buy_price} + $r->{xtra_cost} - $r->{discount});
      my $tax_value = ($r->{tax} / 100)*$row_total;
      my $row_total_wo_tax = $row_total-$tax_value;

      $footers{ $r->{internal_doc_code} }->{ $r->{tax} }->{wo_tax} += $row_total_wo_tax;
      $footers{ $r->{internal_doc_code} }->{ $r->{tax} }->{w_tax} += $row_total;
      $footers{ $r->{internal_doc_code} }->{ $r->{tax} }->{tax_value} += $tax_value;

      push @v, "D";
      push @v, $r->{internal_doc_code};
      push @v, $r->{family_code};
      #push @v, $r->{article_code};
      push @v, $r->{family_name}.$r->{subfamily_name};
      push @v, $r->{article_name};
      push @v, $r->{barcode2};
      push @v, sprintf("%0.3f", $r->{buy_price});
      push @v, sprintf("%0.3f", $r->{discount});
      push @v, sprintf("%0.3f", $r->{xtra_cost});
      push @v, $r->{quantity};
      push @v, $r->{unit_name};
      push @v, $r->{f_qtty};
      push @v, $r->{tax};
      push @v, sprintf("%0.3f", $row_total_wo_tax);
      push @v, sprintf("%0.3f", $row_total);

      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    #print F "R\n";

    $status = $csv->combine(qw/Q id vat_rate vat_value total_wo_vat total_w_vat/);
    print F $csv->string()."\n";

    foreach my $id (sort keys %footers) {
      foreach my $vat (sort keys %{ $footers{$id} }) {
        my $h = $footers{$id}->{$vat};

        my @v = ();
        
        push @v, "R";
        push @v, $id;
        push @v, $vat;
        push @v, sprintf("%0.3f", $h->{tax_value});
        push @v, sprintf("%0.3f", $h->{wo_tax});
        push @v, sprintf("%0.3f", $h->{w_tax});

        my $status = $csv->combine(@v);
        print F $csv->string()."\n";
      }
    }

    close(F);
  }
}

1;

