package WO::Client::Integrators::Customers::Custom3;
# Comograma

use strict;
use warnings;

use base qw ( WO::Client::Common );

use POSIX qw( strftime ceil );
use Archive::Zip qw( :ERROR_CODES :CONSTANTS );
use File::Copy qw( copy move );
use File::Find qw( find );
use File::Spec;
use DBI;
use Text::CSV_XS;
use FindBin qw( $Bin );
use Digest::MD5 qw( md5_hex );
use Data::Dumper;

sub sync_fo_information {
  my $s = shift;
}

sub sync_bk_information {
  my $s = shift;

  $s->debug("sync_bk_information()");

  my $xml = $s->info();

  my $fo_type = $s->encode_fo_type();

  $s->debug("Encoded FO type is: $fo_type");

  my $csv = Text::CSV_XS->new({ binary => 1, sep_char => "#", quote_char => '' });

  # directory separator
  my $dsep = $s->directory_separator();

  my $tmp_dir = $s->tmp_dir();

  my $dir = $s->vfh($xml, 'dir');

  if (! defined $dir) {
    $s->abort("Missing the 'dir' parameter...");
  }

  my $file_documents = $dir.$dsep.'receptions.csv';
  my $file_orders = $dir.$dsep.'orders.csv';
  my $file_sales = $dir.$dsep.'sales.csv';

  my @headers = qw/ Q id date date_of_payment store supplier_code supplier_name supplier_docref doc_type doc_type_name doc_total discount clerk clerk_name order_or_invoice /;
  my @details = qw/ Q id article_code article_name article_name2 buy_price discount xtra_cost quantity unit_name vat_rate /;

  my $status;
  my $str;
  my $VAR1;

  eval {
    $str = $s->weckoffice_send_data( { action => 'GetDocuments_Custom3' } );
  };

  if ($@) {
    die("Error: $@");
  }

  eval $str;

  if (defined $VAR1 && ref($VAR1) eq 'HASH') {
    open(F, "> $file_documents") or die "Can't write to $file_documents";

    $status = $csv->combine(@headers);
    print F $csv->string()."\n";

    my $headers = $VAR1->{headers};
    my $details = $VAR1->{details};

=cut
          {
            'total_payed' => '0.00',
            'date' => '2009-06-29',
            'total_to_pay' => '25.8000',
            'supplier_docref' => '97455583',
            'date_of_payment' => '',
            'store_code' => '002',
            'doc_type_name' => 'Nota Crdito F',
            'discount' => '0',
            'total_iva' => '0.0000',
            'supplier_name' => 'UNICER (D V T)',
            'supplier_code' => 'W0000000058',
            'total_p_iva' => '0=0.0000|19=0.000000|12=0.000000|17=0.000000|5=0.000000|20=0.000000',
            'doc_type' => '200',
            'internal_doc_code' => '9'
          }
=cut

    for (@$headers) {
      my @v = ();

# Q id date date_of_payment store supplier_code supplier_name supplier_docref doc_type doc_type_name doc_total discount clerk clerk_name order_or_invoice

      my $supplier_code = $_->{supplier_code};
      my $supplier_name = $_->{supplier_name};

      if ($_->{franchised}) {
        $supplier_code = $_->{store_code};
        $supplier_name = $_->{store_name};
      }

      push @v, "C";
      push @v, $_->{internal_doc_code};
      push @v, $_->{date};
      push @v, $_->{date_of_payment};
      push @v, $_->{store_code};
      push @v, $supplier_code;
      push @v, $supplier_name;
      push @v, $_->{supplier_docref};
      push @v, $_->{doc_type};
      push @v, $_->{doc_type_name};
      push @v, sprintf("%.3f", $_->{total_to_pay});
      push @v, sprintf("%.3f", $_->{discount});
      push @v, '';
      push @v, '';
      push @v, $_->{franchised};
      
      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    $status = $csv->combine(@details);
    print F $csv->string()."\n";

=pod
          {
            'f_qtty' => '2',
            'subfamily_name' => 'Mercadoria',
            'xtra_cost' => '0',
            'quantity' => '2',
            'subfamily_code' => 'W0000000029',
            'family_code' => 'W0000000028',
            'tax' => '0',
            'barcode2' => '0',
            'discount' => '0',
            'family_name' => 'Mercadoria',
            'article_name' => 'Descapsulador  Balco Super Bock',
            'internal_doc_code' => '9',
            'buy_price' => '12.9',
            'article_code' => '54565',
            'unit_name' => 'un'
          }
=cut

    for (@$details) {
      my @v = ();

# Q id article_code article_name article_name2 buy_price discount xtra_cost quantity unit_name vat_rate 

      push @v, "D";
      push @v, $_->{internal_doc_code};
      push @v, $_->{article_code};
      push @v, $_->{article_name};
      push @v, '';
      push @v, sprintf("%.3f", $_->{buy_price});
      push @v, sprintf("%.3f", $_->{discount});
      push @v, sprintf("%.3f", $_->{xtra_cost});
      push @v, sprintf("%.2f", $_->{quantity});
      push @v, $_->{unit_name};
      push @v, $_->{tax};
      
      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    close(F);
  }

  $VAR1 = undef;

  eval {
    $str = $s->weckoffice_send_data( { action => 'GetSales_Custom3' } );
  };

  if ($@) {
    die("Error: $@");
  }

  eval $str;

  if (defined $VAR1 && ref($VAR1) eq 'ARRAY') {
    open(F, "> $file_sales") or die "Can't write to $file_sales";

=pod
          {
            'user_fo_id' => '170',
            'store' => '58',
            'doc_name' => 'Factura',
            'total_w_tax' => '1.10',
            'date' => '2009-06-10',
            'quantity' => '1',
            'article_fo_id' => '1169',
            'discount' => '0.00',
            'user_name' => 'Luisa',
            'total_wo_tax' => '0.98214285714285714286',
            'doc_type' => '1',
            'tax_value' => '12',
            'fo_doc_number' => 'Z0002052',
            'article_name' => 'Vitalis 500 ml',
            'id' => '52567',
            'doc_value' => '1.1',
            'total_discounts' => '0.00'
          }
=cut

    my $done_headers = {};

    $status = $csv->combine(@headers);
    print F $csv->string()."\n";

    # headers
    for (@$VAR1) {
      if (! exists $done_headers->{ $_->{fo_doc_number} }) {

# Q id date date_of_payment store supplier_code supplier_name supplier_docref doc_type doc_type_name doc_total discount clerk clerk_name order_or_invoice

        my @v = ();

        push @v, "C";
        push @v, $_->{id};
        push @v, $_->{date};
        push @v, '';
        push @v, $_->{store};
        push @v, '';
        push @v, '';
        push @v, $_->{fo_doc_number};
        push @v, $_->{doc_type};
        push @v, $_->{doc_name};
        push @v, sprintf("%.3f", $_->{total_w_tax});
        push @v, sprintf("%.3f", $_->{total_discounts});
        push @v, $_->{user_fo_id};
        push @v, $_->{user_name};
        push @v, 0;

        my $status = $csv->combine(@v);
        print F $csv->string()."\n";

        $done_headers->{ $_->{fo_doc_number} } = 1;
      }
    }

    $status = $csv->combine(@details);
    print F $csv->string()."\n";

    # details
    for (@$VAR1) {
      my @v = ();

# Q id article_code article_name article_name2 buy_price discount xtra_cost quantity unit_name vat_rate 

      push @v, "D";
      push @v, $_->{id};
      push @v, $_->{article_fo_id};
      push @v, $_->{article_name};
      push @v, '';
      push @v, sprintf("%.3f", $_->{total_w_tax});
      push @v, sprintf("%.3f", $_->{discount});
      push @v, 0;
      push @v, sprintf("%.2f", $_->{quantity});
      push @v, '';
      push @v, $_->{tax_value};
      
      my $status = $csv->combine(@v);
      print F $csv->string()."\n";

    }

    close(F);
  }

  $VAR1 = undef;

  eval {
    $str = $s->weckoffice_send_data( { action => 'GetOrders_Custom3' } );
  };

  if ($@) {
    die("Error: $@");
  }

  eval $str;

  if (defined $VAR1 && ref($VAR1) eq 'HASH') {
    open(F, "> $file_orders") or die "Can't write to $file_orders";

    my $headers = $VAR1->{headers};

    $status = $csv->combine(@headers);
    print F $csv->string()."\n";

=pod
          {
            'supplier_code' => '10',
            'supplier_name' => 'Progelcone',
            'franchised' => '0',
            'date' => '2009-06-05',
            'internal_doc_code' => '120',
            'supplier_docref' => 'W0000000212',
            'store_code' => '004'
          }
=cut

    for (@$headers) {
      my @v = ();

# Q id date date_of_payment store supplier_code supplier_name supplier_docref doc_type doc_type_name doc_total discount clerk clerk_name order_or_invoice

      my $supplier_code = $_->{supplier_code};
      my $supplier_name = $_->{supplier_name};

      if ($_->{franchised}) {
        $supplier_code = $_->{store_code};
        $supplier_name = $_->{store_name};
      }

      push @v, "C";
      push @v, $_->{internal_doc_code};
      push @v, $_->{date};
      push @v, '';
      push @v, $_->{store_code};
      push @v, $supplier_code;
      push @v, $supplier_name;
      push @v, $_->{supplier_docref};
      push @v, 'ENC';
      push @v, 'Encomenda';
      push @v, 0;
      push @v, 0;
      push @v, '';
      push @v, '';
      push @v, $_->{franchised};

      $s->dump(\@v);
      
      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    my $details = $VAR1->{details};

    $status = $csv->combine(@details);
    print F $csv->string()."\n";

=pod
          {
            'f_qtty' => '3000',
            'quantity' => '1',
            'tax' => '20',
            'discount' => '0',
            'internal_doc_code' => '120',
            'article_name' => 'Guardanapos 33*33',
            'buy_price' => '32.6100',
            'unit_name' => 'Cx3000un',
            'article_code' => '119707'
          }
=cut

    for (@$details) {
      my @v = ();

# Q id article_code article_name article_name2 buy_price discount xtra_cost quantity unit_name vat_rate 

      push @v, "D";
      push @v, $_->{internal_doc_code};
      push @v, $_->{article_code};
      push @v, $_->{article_name};
      push @v, '';
      push @v, sprintf("%.3f", $_->{buy_price});
      push @v, sprintf("%.3f", $_->{discount});
      push @v, 0;
      push @v, sprintf("%.2f", $_->{quantity});
      push @v, $_->{unit_name};
      push @v, $_->{tax};
      
      my $status = $csv->combine(@v);
      print F $csv->string()."\n";
    }

    close(F);
  }
}

1;

