package WO::Client::Integrators::ParProva;

use strict;
use warnings;
use POSIX qw( strftime );

use base qw ( WO::Client::Common );

use Win32::Printer::Direct;

my %ERROR_CODES = (
  '1'   => 'Success',
  '-1'  => 'Memory allocation error',
  '-2'  => 'Error opening the file',
  '-3'  => 'Error opening the printer',
  '-4'  => 'Error startint the print job',
  '-5'  => 'Error writing to printer',
  '-6'  => 'Error ending the print job',
  '-7'  => 'Error closing printer',
);

sub sync_fo_information {}

sub sync_bk_information {
  my $s = shift;

  $s->debug("sync_bk_information()");

  # service xml
  my $xml = $s->info();

  # directory separator
  my $dsep = $s->directory_separator();

  my $win32_printer_name = $xml->{win32_printer_name} || "";

  if ($win32_printer_name) {
    my $tmp_file = $s->tmp_dir() . $dsep . int(rand(1000000));
    #my $tmp_file = 'c:\t.txt';

    my $VAR1 = undef;
    my $str;

    eval {
      $str = $s->weckoffice_send_data( { action => 'BackofficeGetCompanyTStocks',
                                       }
                                     );
    };

    if ($@) {
      die("Error: $@");
    }

    eval $str;

    if (defined $VAR1 && ref($VAR1) eq 'HASH') {
      open(F, "> $tmp_file") or die "Can't write to $tmp_file: $!";
      foreach my $store_id (sort {$VAR1->{$a}->{name} cmp $VAR1->{$b}->{name}} keys %$VAR1) {
        if (scalar @{ $VAR1->{$store_id}->{articles} }) {
          print F "=" x length($VAR1->{$store_id}->{name});
          print F "\n".$VAR1->{$store_id}->{name}."\n";
          print F "=" x length($VAR1->{$store_id}->{name});
          print F "\n\n";
        }

=pod
  $VAR1 = {
                                      'article_id' => '3',
                                      'bellow_smin' => 1,
                                      'article_name' => 'Sagres Lata 0,50Lt.',
                                      'stock_max' => '192',
                                      'stock_min' => '72',
                                      'unidade_name' => 'Un',
                                      'article_fo_id' => '3',
                                      'curr_stock' => '0'
          };
=cut

        foreach my $a (sort { $a->{article_name} cmp $b->{article_name} } @{ $VAR1->{$store_id}->{articles} }) {
          next unless defined $a->{curr_stock};

          #if ($a->{bellow_smin}) {
            my $art_name = sprintf("%-50s", $a->{article_name}." (".$a->{bellow_smin}.")");
            my $cur_stock = sprintf("%-15s", $a->{curr_stock}." ".$a->{unidade_name});
            print F $art_name."\t".$cur_stock."\n";
          #}
        }

        print F "\n" if scalar @{ $VAR1->{$store_id}->{articles} };
      }

      my $size = -s $tmp_file;

      $s->debug("Generated file has $size bytes...");

      if (-s $tmp_file) {
        my $st = Printfile($win32_printer_name, $tmp_file);
        $s->debug("Result from printer command (printer name: $win32_printer_name) - ".$ERROR_CODES{$st});
      }

      $s->own_remove( $tmp_file );
    }
  } else {
    $s->debug("You didn't define a 'win32_printer_name' parameter...");
  }
}