package WinRest::File::Articles;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

sub cache_key_field { 'mart_codg' }

sub fields {
  ( { mart_codg => 6  },
    { mart_cped => 5  },
    { mart_meia => 6  },
    { mart_fami => 4  },
    { mart_nome => 40 },
    { mart_ncur => 13 },
    { mart_nbot => 32 },
    { mart_vord => 3  },
    { mart_size => 1  },
    { mart_tipo => 1  },
    { mart_unid => 2  },
    { mart_cntn => 7  },
    { mart_gdsc => 1  },
    { mart_gcoa => 1  },
    { mart_oimp => 1  },
    { mart_oimd => 1  },
    { mart_zimp => 2  },
    { mart_iva1 => 1  },
    { mart_iva2 => 1  },
    { mart_1_pv => 12 },
    { mart_2_pv => 12 },
    { mart_3_pv => 12 },
    { mart_4_pv => 12 },
    { mart_5_pv => 12 },
    { mart_papv => 1  },
    { mart_pofe => 1  },
    { mart_comp => 1  },
    { mart_tart => 1  },
    { mart_cbot => 3  },
    { mart_cbar => 20 },
    { mart_tara => 8  },
    { mart_peso => 11 },

    { mart_movi => 1  },
    { mart_anul => 1  },
    { mart_data => 10 },

    { mart_unknown1     => 1 },
    { mart_is_sale      => 1 },
    { mart_is_composite => 1 },

    { mart_nexp => 6  },
#    { mart_test => 9  },
  );
}

sub defaults {
  ( #{ mart_codg => undef },
    { mart_cped => 0  },
    { mart_meia => 0  },
    #{ mart_fami => undef },
    { mart_nome => "Article name" },
    { mart_ncur => "Article name" },
    { mart_nbot => "Article name" },
    { mart_size => 2  },
    { mart_tipo => 0  },
    { mart_unid => "Un" },
    { mart_cntn => 1 },
    { mart_gdsc => 1  },
    { mart_gcoa => 1  },
    { mart_oimp => 1  },
    { mart_oimd => 1  },
    { mart_zimp => 3  },
    { mart_iva1 => 5  },
    { mart_iva2 => 5  },
    { mart_1_pv => "0" },
    { mart_2_pv => "0" },
    { mart_3_pv => "0" },
    { mart_4_pv => "0" },
    { mart_5_pv => "0" },
    { mart_papv => "F"  },
    { mart_pofe => "T"  },
    { mart_comp => 0  },
    { mart_tart => 0  },
    { mart_cbot => 255 },
    { mart_cbar => "" },
    { mart_tara => "0.000" },
    { mart_peso => "0.000000" },

    { mart_movi => "T" },
    { mart_anul => "F" },
    { mart_data => "01/01/1970" },

    { mart_unknown1     => 'A' },
    { mart_is_sale      => 'T' },
    { mart_is_composite => 'F' },

    { mart_nexp => 9 },
  );
}

1;

