package WinRest::File::Clients;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

sub fields {
  ( { mcli_codg => 6  },
    { mcli_asso => 6  },
    { mcli_nome => 40 },
    { mcli_mora => 35 },
    { mcli_loca => 30 },
    { mcli_cpos => 25 },
    { mcli_telf => 20 },
    { mcli_fax  => 20 },
    { mcli_ctrb => 20 },
    { mcli_gdsc => 1  },
    { mcli_ncrd => 10 },
    { mcli_dcrd => 10 },
    { mcli_ncmn => 6  },
    { mcli_qcli => 1  },
    { mcli_limi => 13 },
    { mcli_tcre => 13 },
    { mcli_tdeb => 13 },
    { mcli_sald => 13 },
    { mcli_dnas => 10 },
    { mcli_zona => 4  },
    { mcli_obsv => 44 },
    { mcli_pont => 6  },
    { mcli_obsm => 40 },
    { mcli_movi => 1  },
    { mcli_anul => 1  },
    { mcli_data => 10 },
    { mcli_nexp => 9  },
  );
}

sub defaults {
  ( { mcli_codg => undef  },
    { mcli_asso => 0  },
    { mcli_nome => undef },
    { mcli_mora => "" },
    { mcli_loca => "" },
    { mcli_cpos => "" },
    { mcli_telf => "" },
    { mcli_fax  => "" },
    { mcli_ctrb => "" },
    { mcli_gdsc => 0  },
    { mcli_ncrd => "" },
    { mcli_dcrd => "01/01/2100" },
    { mcli_ncmn => 0  },
    { mcli_qcli => 0  },
    { mcli_limi => "0.00" },
    { mcli_tcre => "0.00" },
    { mcli_tdeb => "0.00" },
    { mcli_sald => "0.00" },
    { mcli_dnas => "" },
    { mcli_zona => 0  },
    { mcli_obsv => "" },
    { mcli_pont => 0  },
    { mcli_obsm => ""},

    {  mcli_movi => "T" },
    {  mcli_anul => "F" },
    {  mcli_data => "31/12/2020" },
    {  mcli_nexp => 9 },
  );
}

1;
