package WinRest::File::Families;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

sub cache_key_field { 'mfam_codg' }

sub fields {
  ( { mfam_codg => 4  },
    { mfam_nome => 40 },
    { mfam_ncur => 13 },
    { mfam_nbot => 32 },
    { mfam_vord => 2  },
    { mfam_cpat => 1  },
    { mfam_size => 1  },
    { mfam_tipo => 1  },
    { mfam_unid => 2  },
    { mfam_cntn => 7  },
    { mfam_gdsc => 1  },
    { mfam_gcoa => 1  },
    { mfam_oimp => 1  },
    { mfam_oimd => 1  },
    { mfam_zimp => 2  },
    { mfam_iva1 => 1  },
    { mfam_iva2 => 1  },
    { mfam_1_pv => 12 },
    { mfam_2_pv => 12 },
    { mfam_3_pv => 12 },
    { mfam_4_pv => 12 },
    { mfam_5_pv => 12 },
    { mfam_papv => 1  },
    { mfam_pofe => 1  },
    { mfam_comp => 1  },
    { mfam_tart => 1  },
    { mfam_cbot => 3  },
    { mfam_tara => 8  },
    { mfam_peso => 11 },
    
    { mfam_movi => 1  },
    { mfam_anul => 1  },
    { mfam_data => 10 },
    { mfam_nexp => 9  },
#    { mfam_test => 9  },
  );
}

sub defaults {
  ( #{ mfam_codg => "200" },
    { mfam_nome => "Family name" },
    { mfam_ncur => "Family name" },
    { mfam_nbot => "Family name" },
    { mfam_vord => "" },
    { mfam_cpat => "F" },
    { mfam_size => 1 },
    { mfam_tipo => 0 },
    { mfam_unid => "Un" },
    { mfam_cntn => "1.00" },
    { mfam_gdsc => 1  },
    { mfam_gcoa => 1  },
    { mfam_oimp => 1  },
    { mfam_oimd => 1  },
    { mfam_zimp => 13 },
    { mfam_iva1 => 2  },
    { mfam_iva2 => 1  },
    { mfam_1_pv => "0.50" },
    { mfam_2_pv => "0.60" },
    { mfam_3_pv => "0.70" },
    { mfam_4_pv => "0.90" },
    { mfam_5_pv => "0.30" },
    { mfam_papv => "F" },
    { mfam_pofe => "T" },
    { mfam_comp => 0 },
    { mfam_tart => 0 },
    { mfam_cbot => 255 },
    { mfam_tara => "0.000" },
    { mfam_peso => "0.000000" },

    { mfam_movi => "T" },
    { mfam_anul => "F" },
    { mfam_data => "01/01/1970" },
    { mfam_nexp => 9 },
  );
}

1;




























