package WinRest::File::Parameters;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

#sub cache_key_field { 'memp_codg' }

#
# This spec is according the WinREST FO version 5.5 formats
#

sub fields {
  ( { param_type  => 4  },
    { code        => 10 },
    { description => 20 },
    { param_value => 13 },
    { text        => 4  },

    { mart_movi => 1  },
    { mart_anul => 1  },
    { mart_data => 10 },
    { mart_nexp => 9  },
  );
}

sub defaults {
  ( { param_type  => "" },
    { code        => "" },
    { description => "" },
    { param_value => "" },
    { text        => "" },

    { mart_movi => "T" },
    { mart_anul => "F" },
    { mart_data => "01/01/1970" },
    { mart_nexp => 9 },
  );
}

1;
