package WinRest::File::Waitress;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

sub cache_key_field { 'memp_codg' }

#
# This spec is according the WinREST FO version 5.5 formats
#

sub fields {
  ( { memp_codg => 6  },
    { memp_nome => 39 },
    { memp_tmp  => 1  }, # isto est aqui pq numa empresa entre o nome e o nint havia um 0 e no fao ideia pq seria - provavelmente vou ter de tirar isto no futuro
    { memp_nint => 16 },
    { memp_mora => 35 },
    { memp_loca => 30 },
    { memp_cpos => 25 },
    { memp_telf => 20 },
    { memp_ctrb => 20 },
    { memp_iden => 20 },
    { memp_dadm => 10 },
    { memp_ncrd => 10 },
    { memp_mrcm => 1  },
    { memp_npcm => 1  },
    { memp_gcoe => 1  },
    { memp_ctge => 1  },
    { memp_pasw => 4  },
    { memp_cbot => 3  },
    { memp_mesa => 32 },
    { memp_lmea => 1  },
    { memp_aped => 1  },
    { memp_apcc => 1  },
    { memp_tped => 1  },
    { memp_tcon => 1  },
    { memp_trec => 1  },
    { memp_trcm => 1  },
    { memp_tfac => 1  },
    { memp_accs => 1  },
    { memp_pvpo => 1  },
    { memp_psvo => 6  },
    { memp_vpbo => 9  },
    { memp_pvpc => 1  },
    { memp_psvc => 6  },
    { memp_vpbc => 9  },

    { memp_movi => 1  },
    { memp_anul => 1  },
    { memp_data => 10 },
    { memp_nexp => 9  },
#    { memp_test => 9  },
  );
}

sub defaults {
  ( { memp_codg => undef  },
    { memp_nome => undef },
    { memp_nint => undef },
    { memp_mora => "Morada" },
    { memp_loca => "Localidade" },
    { memp_cpos => "4100" },
    { memp_telf => "225322000" },
    { memp_ctrb => "123123123" },
    { memp_iden => "123123123" },
    { memp_dadm => "01/01/1970" },
    { memp_ncrd => "" },
    { memp_mrcm => 0  },
    { memp_npcm => 0  },
    { memp_gcoe => ""  },
    { memp_ctge => "3"  },
    { memp_pasw => "" },
    { memp_cbot => "255"  },
    { memp_mesa => "1:9999" },
    { memp_lmea => 0  },
    { memp_aped => 0  },
    { memp_apcc => 0  },
    { memp_tped => 0  },
    { memp_tcon => 0  },
    { memp_trec => 0  },
    { memp_trcm => 0  },
    { memp_tfac => 0  },
    { memp_accs => 0  },
    { memp_pvpo => 0  },
    { memp_psvo => 0  },
    { memp_vpbo => 0  },
    { memp_pvpc => 0  },
    { memp_psvc => 0  },
    { memp_vpbc => 0  },

    { memp_movi => "T" },
    { memp_anul => "F" },
    { memp_data => "01/01/1970" },
    { memp_nexp => 0 },
  );
}

1;






