package WinRest::File::Waitress_5_5_0;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

#
# This spec is according the WinREST FO version 5.5 formats
#

sub fields {
  ( { code                   => 6  },
    { name                   => 38 },
    { language               => 2 },
    { internal_name          => 16 },
    { address                => 35 },
    { city                   => 30 },
    { postal_code            => 25 },
    { phone                  => 20 },
    { tax_number             => 20 },
    { identification         => 20 },
    { hire_date              => 10 },
    { card_number            => 10 },
    { receive_from           => 1  },
    { send_to                => 1  },
    { comission_code         => 1  },
    { category               => 1  },
    { passwfo                => 4  },
    { button_color           => 3  },
    { table_group            => 32 },
    { locks_table            => 1  },
    { purge_order            => 1  },
    { purge_wsubtotal_orders => 1  },
    { handle_order           => 1  },
    { query_table            => 1  },
    { close_table            => 1  },
    { radio_close_table      => 1  },
    { handle_invoice         => 1  },
    { update_cc              => 1  },
    { offer_price_code       => 1  },
    { perc_price_offer       => 6  },
    { base_offer             => 9  },
    { consumption_price      => 1  },
    { perc_comsumption       => 6  },
    { base_comsumption       => 9  },
  );
}

sub defaults {
  ( { code                   => undef        },
    { name                   => undef        },
    { language               => 0            },
    { internal_name          => undef        },
    { address                => "Morada"     },
    { city                   => "Cidade"     },
    { postal_code            => "0000-000"   },
    { phone                  => "000000000"  },
    { tax_number             => "000000000"  },
    { identification         => "00000000"   },
    { hire_date              => "1970/01/01" },
    { card_number            => "000000"     },
    { receive_from           => ""           },
    { send_to                => ""           },
    { comission_code         => 0            },
    { category               => ""           },
    { passwfo                => ""           },
    { button_color           => ""           },
    { table_group            => ""           },
    { locks_table            => ""           },
    { purge_order            => ""           },
    { purge_wsubtotal_orders => ""           },
    { handle_order           => ""           },
    { query_table            => ""           },
    { close_table            => ""           },
    { radio_close_table      => ""           },
    { handle_invoice         => ""           },
    { update_cc              => ""           },
    { offer_price_code       => ""           },
    { perc_price_offer       => ""           },
    { base_offer             => ""           },
    { consumption_price      => ""           },
    { perc_comsumption       => ""           },
    { base_comsumption       => ""           },
  );
}

1;





