package WinRest::File::Warehouses;

use strict;
use warnings;

use base qw( WinRest::File::Fields );

sub cache_key_field { 'marm_codg' }

#
# This spec is according the WinREST FO version 5.5 formats
#

sub fields {
  ( { marm_codg => 6  },
    { marm_nome => 20 },
    { marm_movi => 1  },
    { marm_anul => 1  },
    { marm_data => 10 },
    { marm_nexp => 9  },
  );  
}

sub defaults {
  ( { marm_codg => undef  },
    { marm_nome => undef },
    { marm_movi => "T" },
    { marm_anul => "F" },
    { marm_data => "01/01/1970" },
    { marm_nexp => 9 },
  );
}

1;
