package WinTouch::Export::Artigos;

use strict;
use warnings;

use base qw( WinTouch::Export );

sub key_fields { qw/ Codigo CodBarras / }

sub fields {
  return qw( AbrevImpressao AbrevMonitor AbrevTecla Activo Actualizar Armazem ArmFront ArtCompra ArtProducao ArtServico
             ArtTempo ArtVenda blnFraccoes blnMetades CodBarras CodFornecedor Codigo CodTerminal Comentario1 Comentario2
             Comentario3 Comentario4 Comentario5 ConsumoPosterior ContaCBL ControlaDoses ControlaExistencia CustoArtigo
             CustoUnitario DataUltCmp DataUltInv DataUltVnd Descricao Existencia ExistenciaUltInv Exportado FactorCompra
             FactorIndirecta FactorVenda Familia Fornecedor FuncionaComoComentario HappyHour Imagem Impressora Impressora2
             Impressora3 IntervaloTempo Iva Iva1 IvaCompra Menu Monitor Monitor2 Monitor3 NaoImprimeAnulacao NivelAnulacao
             NivelMinimo Observacoes OrdemImpr PedeQtd PMP Preco1 Preco2 Preco3 Preco4 Preco5 PrecoManual PrecoMeiaDose
             Promo Tara TemposMonitor TipoFichaTecnica TipoPromocao UltimaModificacao UltPrecoCmp UnCompra UnStock UnVenda
             VendaAPeso
           );
}

sub defaults {
  return (
    AbrevImpressao => "Agua Vitalis",
    AbrevMonitor => "Agua Vitalis",
    AbrevTecla => "",
    Activo => "1",
    Actualizar => "0",
    Armazem => "001",
    ArmFront => "0",
    ArtCompra => "1",
    ArtProducao => "0",
    ArtServico => "0",
    ArtTempo => "0",
    ArtVenda => "1",
    blnFraccoes => "1",
    blnMetades => "0",
    CodBarras => "B0001",
    CodFornecedor => "",
    Codigo => "B0001",
    CodTerminal => "0151",
    Comentario1 => "",
    Comentario2 => "",
    Comentario3 => "",
    Comentario4 => "",
    Comentario5 => "",
    ConsumoPosterior => "0",
    ContaCBL => "",
    ControlaDoses => "0",
    ControlaExistencia => "1",
    CustoArtigo => "0",
    CustoUnitario => "0",
    DataUltCmp => "10-31-2004 00:00:00",
    DataUltInv => "05-29-2004 00:00:00",
    DataUltVnd => "08-14-2004 00:00:00",
    Descricao => "gua Vitalis",
    Existencia => "362",
    ExistenciaUltInv => "0",
    Exportado => "0",
    FactorCompra => "24",
    FactorIndirecta => "0",
    FactorVenda => "1",
    Familia => "001",
    Fornecedor => "001",
    FuncionaComoComentario => "0",
    HappyHour => "",
    Imagem => "",
    Impressora => "BAR",
    Impressora2 => "",
    Impressora3 => "",
    IntervaloTempo => "0",
    Iva => "INT",
    Iva1 => "NOR",
    IvaCompra => "NOR",
    Menu => "0",
    Monitor => "",
    Monitor2 => "",
    Monitor3 => "",
    NaoImprimeAnulacao => "0",
    NivelAnulacao => "0",
    NivelMinimo => "0",
    Observacoes => "",
    OrdemImpr => "2",
    PedeQtd => "0",
    PMP => "28.96",
    Preco1 => "0.9",
    Preco2 => "0.9",
    Preco3 => "0.8",
    Preco4 => "0.8",
    Preco5 => "0.7",
    PrecoManual => "0",
    PrecoMeiaDose => "0",
    Promo => "0",
    Tara => "0",
    TemposMonitor => "",
    TipoFichaTecnica => "1",
    TipoPromocao => "",
    UltimaModificacao => "10-09-2004 00:00:00",
    UltPrecoCmp => "0.08",
    UnCompra => "GRADE24",
    UnStock => "GARRAFA",
    UnVenda => "GARRAFA",
    VendaAPeso => "0",
  );
}

1;

