package WinTouch::Export::Familias;

use strict;
use warnings;

use base qw( WinTouch::Export );

sub key_fields { qw/ Codigo / }

sub fields {
  return qw( Armazem ArtCompra ArtVenda Codigo Comentario1 Comentario2 Comentario3
             ContaCBL ControlaDoses ControlaExistencia Descricao Exportado FactorCompra
             FactorIndirecta FactorVenda Grupo HappyHour Impressora Impressora2 Iva Iva1
             IvaCompra Monitor NaoImprimeAnulacao NivelMinimo Preco1 Preco2 Preco3 Preco4
             Preco5 UnCompra UnStock UnVenda
           );
}

sub defaults {
  return (
    Armazem => "",
    ArtCompra => "",
    ArtVenda => "",
    Codigo => undef,
    Comentario1 => "",
    Comentario2 => "",
    Comentario3 => "",
    ContaCBL => "",
    ControlaDoses => "",
    ControlaExistencia => "",
    Descricao => undef,
    Exportado => "",
    FactorCompra => "1",
    FactorIndirecta => "",
    FactorVenda => "1",
    Grupo => "",
    HappyHour => "",
    Impressora => "",
    Impressora2 => "",
    Iva => "",
    Iva1 => "",
    IvaCompr => "",
    Monitor => "",
    NaoImprimeAnulacao => "",
    NivelMinimo => 0,
    Preco1 => 0,
    Preco2 => 0,
    Preco3 => 0,
    Preco4 => 0,
    Preco5 => 0,
    UnCompra => "",
    UnStock => "",
    UnVenda => "",
   );
}

1;
